/* The following code was generated by JFlex 1.7.0 tweaked for IntelliJ platform */

package com.renpyplugin;

import com.intellij.lexer.FlexLexer;
import com.intellij.psi.tree.IElementType;
import com.renpyplugin.psi.RenpyTypes;
import com.intellij.psi.TokenType;


/**
 * This class is a scanner generated by 
 * <a href="http://www.jflex.de/">JFlex</a> 1.7.0
 * from the specification file <tt>Renpy.flex</tt>
 */
class RenpyLexer implements FlexLexer {

  /** This character denotes the end of file */
  public static final int YYEOF = -1;

  /** initial size of the lookahead buffer */
  private static final int ZZ_BUFFERSIZE = 16384;

  /** lexical states */
  public static final int YYINITIAL = 0;
  public static final int WAITING_VARIABLE_NAME_DEFINE = 2;
  public static final int WAITING_VARIABLE_NAME_SHOW = 4;
  public static final int WAITING_TAGS_DEFINE = 6;
  public static final int WAITING_TAGS_SHOW = 8;
  public static final int WAITING_BLOCK_NAME = 10;
  public static final int WAITING_PARAMS = 12;
  public static final int WAITING_VALUE = 14;
  public static final int CLASS1 = 16;
  public static final int CLASS2 = 18;
  public static final int CLASS3 = 20;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = { 
     0,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7,  8,  8, 
     9,  9, 10, 10, 11, 11
  };

  /** 
   * Translates characters to character classes
   * Chosen bits are [11, 6, 4]
   * Total runtime size is 15360 bytes
   */
  public static int ZZ_CMAP(int ch) {
    return ZZ_CMAP_A[(ZZ_CMAP_Y[(ZZ_CMAP_Z[ch>>10]<<6)|((ch>>4)&0x3f)]<<4)|(ch&0xf)];
  }

  /* The ZZ_CMAP_Z table has 1088 entries */
  static final char ZZ_CMAP_Z[] = zzUnpackCMap(
    "\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\6\15\1\16\23\15"+
    "\1\17\1\15\1\20\1\21\12\15\1\22\10\12\1\23\1\24\1\25\1\26\1\27\1\30\1\31\1"+
    "\32\1\33\1\34\1\35\1\36\2\12\1\15\1\37\3\12\1\40\10\12\1\41\1\42\5\15\1\43"+
    "\1\44\11\12\1\45\2\12\1\46\4\12\1\47\1\50\1\51\1\12\1\52\1\12\1\53\1\54\1"+
    "\55\3\12\51\15\1\56\3\15\1\57\1\60\4\15\1\61\12\12\1\62\u02c1\12\1\63\277"+
    "\12");

  /* The ZZ_CMAP_Y table has 3328 entries */
  static final char ZZ_CMAP_Y[] = zzUnpackCMap(
    "\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\1\1\11\1\12\1\13\1\14\1\13\1\14\34"+
    "\13\1\15\1\16\1\17\1\1\7\13\1\20\1\21\1\13\1\22\4\13\1\23\10\13\1\22\12\13"+
    "\1\4\1\13\1\24\1\4\1\13\1\25\1\4\1\13\1\26\1\27\1\13\1\30\1\31\1\1\1\30\4"+
    "\13\1\32\6\13\1\33\1\34\1\35\1\1\3\13\1\36\6\13\1\16\3\13\1\37\2\13\1\40\1"+
    "\1\1\13\1\41\4\1\1\13\1\42\1\1\1\43\1\22\7\13\1\44\1\4\1\33\1\45\1\34\1\46"+
    "\1\47\1\50\1\44\1\16\1\51\1\45\1\34\1\52\1\53\1\54\1\55\1\56\1\57\1\22\1\34"+
    "\1\60\1\61\1\62\1\44\1\63\1\64\1\45\1\34\1\60\1\65\1\66\1\44\1\67\1\70\1\71"+
    "\1\72\1\32\1\73\1\74\1\55\1\1\1\75\1\76\1\34\1\77\1\100\1\101\1\44\1\1\1\75"+
    "\1\76\1\34\1\102\1\100\1\103\1\44\1\104\1\105\1\76\1\13\1\36\1\106\1\107\1"+
    "\44\1\110\1\111\1\112\1\13\1\113\1\114\1\115\1\55\1\116\1\4\2\13\1\30\1\117"+
    "\1\120\2\1\1\121\1\122\1\123\1\124\1\125\1\126\2\1\1\62\1\127\1\120\1\130"+
    "\1\131\1\13\1\132\1\4\1\133\1\131\1\13\1\132\1\134\3\1\4\13\1\120\4\13\1\40"+
    "\2\13\1\135\2\13\1\136\24\13\1\137\1\140\2\13\1\137\2\13\1\141\1\142\1\14"+
    "\3\13\1\142\3\13\1\36\2\1\1\13\1\1\5\13\1\143\1\4\45\13\1\35\1\13\1\144\1"+
    "\30\4\13\1\145\1\146\1\147\1\150\1\13\1\150\1\13\1\151\1\147\1\152\5\13\1"+
    "\153\1\120\1\1\1\154\1\120\5\13\1\25\2\13\1\30\4\13\1\56\1\13\1\117\2\41\1"+
    "\55\1\13\1\40\1\150\2\13\1\41\1\13\2\120\2\1\1\13\1\41\3\13\1\117\1\13\1\35"+
    "\2\120\1\155\1\117\4\1\4\13\1\41\1\120\1\156\1\151\7\13\1\151\3\13\1\25\1"+
    "\77\2\13\1\40\1\146\4\1\1\157\1\13\1\160\17\13\1\161\21\13\1\143\2\13\1\143"+
    "\1\162\1\13\1\40\3\13\1\163\1\164\1\165\1\132\1\164\1\166\1\1\1\167\1\170"+
    "\1\62\1\171\1\1\1\172\1\1\1\132\3\1\2\13\1\62\1\173\1\174\1\175\1\126\1\176"+
    "\1\1\2\13\1\146\62\1\1\55\2\13\1\120\161\1\2\13\1\117\2\13\1\117\10\13\1\177"+
    "\1\151\2\13\1\135\3\13\1\200\1\170\1\13\1\201\4\202\2\13\2\1\1\170\35\1\1"+
    "\203\1\1\1\4\1\204\1\4\4\13\1\205\1\4\4\13\1\136\1\206\1\13\1\40\1\4\4\13"+
    "\1\117\1\1\1\13\1\30\3\1\1\13\40\1\133\13\1\56\4\1\135\13\1\56\2\1\10\13\1"+
    "\132\4\1\2\13\1\40\20\13\1\132\1\13\1\41\1\1\3\13\1\207\7\13\1\16\1\1\1\210"+
    "\1\211\5\13\1\212\1\13\1\117\1\25\3\1\1\210\2\13\1\25\1\1\3\13\1\151\4\13"+
    "\1\56\1\120\1\13\1\213\2\13\1\40\2\13\1\151\1\13\1\132\4\13\1\214\1\120\1"+
    "\13\1\117\3\13\1\201\1\40\1\120\1\13\1\112\4\13\1\31\1\154\1\13\1\215\1\216"+
    "\1\217\1\202\2\13\1\136\1\56\7\13\1\220\1\120\72\13\1\151\1\13\1\221\2\13"+
    "\1\41\20\1\26\13\1\40\6\13\1\120\2\1\1\201\1\222\1\34\1\223\1\224\6\13\1\16"+
    "\1\1\1\225\25\13\1\40\1\1\4\13\1\211\2\13\1\25\2\1\1\41\1\13\1\1\1\13\1\226"+
    "\1\227\2\1\1\133\7\13\1\132\1\1\1\120\1\4\1\230\1\4\1\30\1\55\4\13\1\117\1"+
    "\231\1\232\2\1\1\233\1\13\1\14\1\234\2\40\2\1\7\13\1\30\4\1\3\13\1\150\7\1"+
    "\1\235\10\1\1\13\1\132\3\13\2\62\1\1\2\13\1\1\1\13\1\30\2\13\1\30\1\13\1\40"+
    "\2\13\1\236\1\237\2\1\11\13\1\40\1\120\2\13\1\236\1\13\1\41\2\13\1\25\3\13"+
    "\1\151\11\1\23\13\1\201\1\13\1\56\1\25\11\1\1\240\2\13\1\241\1\13\1\56\1\13"+
    "\1\201\1\13\1\117\4\1\1\13\1\242\1\13\1\56\1\13\1\120\4\1\3\13\1\243\4\1\1"+
    "\244\1\245\1\13\1\246\2\1\1\13\1\132\1\13\1\132\2\1\1\131\1\13\1\201\1\1\3"+
    "\13\1\56\1\13\1\56\1\13\1\31\1\13\1\16\6\1\4\13\1\146\3\1\3\13\1\31\3\13\1"+
    "\31\60\1\4\13\1\201\1\1\1\55\1\170\3\13\1\30\1\1\1\13\1\146\1\120\3\13\1\133"+
    "\1\1\2\13\1\247\4\13\1\250\1\251\2\1\1\13\1\22\1\13\1\252\4\1\1\253\1\26\1"+
    "\146\3\13\1\30\1\120\1\33\1\45\1\34\1\60\1\65\1\254\1\255\1\150\10\1\4\13"+
    "\1\30\1\120\2\1\4\13\1\256\1\120\12\1\3\13\1\257\1\62\1\260\2\1\4\13\1\261"+
    "\1\120\2\1\3\13\1\25\1\120\3\1\1\13\1\77\1\41\1\120\26\1\4\13\1\120\1\170"+
    "\34\1\3\13\1\146\20\1\1\34\2\13\1\14\1\62\1\120\1\1\1\211\1\13\1\211\1\131"+
    "\1\201\64\1\71\13\1\120\6\1\6\13\1\117\1\1\14\13\1\151\53\1\2\13\1\117\75"+
    "\1\44\13\1\201\33\1\43\13\1\146\1\13\1\117\1\120\6\1\1\13\1\40\1\150\3\13"+
    "\1\201\1\151\1\120\1\225\1\262\1\13\67\1\4\13\1\150\2\13\1\117\1\170\1\13"+
    "\4\1\1\62\1\1\76\13\1\132\1\1\57\13\1\31\20\1\1\16\77\1\6\13\1\30\1\132\1"+
    "\146\1\263\114\1\1\264\1\265\1\266\1\1\1\267\11\1\1\270\33\1\5\13\1\133\3"+
    "\13\1\147\1\271\1\272\1\273\3\13\1\274\1\275\1\13\1\276\1\277\1\76\24\13\1"+
    "\257\1\13\1\76\1\136\1\13\1\136\1\13\1\133\1\13\1\133\1\117\1\13\1\117\1\13"+
    "\1\34\1\13\1\34\1\13\1\300\3\13\40\1\3\13\1\221\2\13\1\132\1\301\1\302\1\156"+
    "\1\4\25\1\1\14\1\212\1\303\75\1\14\13\1\150\1\201\2\1\4\13\1\30\1\120\112"+
    "\1\1\273\1\13\1\304\1\305\1\306\1\307\1\310\1\311\1\312\1\41\1\313\1\41\47"+
    "\1\1\13\1\120\1\13\1\120\1\13\1\120\47\1\55\13\1\201\2\1\103\13\1\150\15\13"+
    "\1\40\150\13\1\16\25\1\41\13\1\40\56\1\17\13\41\1");

  /* The ZZ_CMAP_A table has 3264 entries */
  static final char ZZ_CMAP_A[] = zzUnpackCMap(
    "\11\0\1\4\1\2\2\3\1\1\22\0\1\4\1\0\1\10\1\7\1\35\3\0\1\34\1\41\2\0\1\40\1"+
    "\0\1\33\1\0\12\5\1\37\2\0\1\36\3\0\32\5\1\0\1\11\2\0\1\5\1\0\1\14\1\32\1\26"+
    "\1\17\1\16\1\20\1\15\1\27\1\12\2\5\1\23\1\13\1\21\1\30\3\5\1\25\1\24\1\22"+
    "\1\5\1\31\3\5\12\0\1\3\12\0\1\6\11\0\1\5\12\0\1\5\4\0\1\5\5\0\27\5\1\0\12"+
    "\5\4\0\14\5\16\0\5\5\7\0\1\5\1\0\1\5\1\0\5\5\1\0\2\5\2\0\4\5\1\0\1\5\6\0\1"+
    "\5\1\0\3\5\1\0\1\5\1\0\4\5\1\0\23\5\1\0\20\5\2\0\1\5\6\0\10\5\10\0\16\5\1"+
    "\0\1\5\1\0\2\5\1\0\2\5\1\0\1\5\10\0\13\5\5\0\3\5\15\0\12\5\4\0\6\5\1\0\10"+
    "\5\2\0\12\5\1\0\23\5\2\0\14\5\2\0\11\5\4\0\1\5\5\0\16\5\2\0\14\5\4\0\5\5\1"+
    "\0\10\5\6\0\20\5\2\0\13\5\2\0\16\5\1\0\1\5\3\0\4\5\2\0\11\5\2\0\2\5\2\0\4"+
    "\5\10\0\1\5\4\0\2\5\1\0\1\5\1\0\3\5\1\0\6\5\4\0\2\5\1\0\2\5\1\0\2\5\1\0\2"+
    "\5\2\0\1\5\1\0\5\5\4\0\2\5\2\0\3\5\3\0\1\5\7\0\4\5\1\0\1\5\7\0\20\5\13\0\3"+
    "\5\1\0\11\5\1\0\2\5\1\0\2\5\1\0\5\5\2\0\12\5\1\0\3\5\1\0\3\5\2\0\1\5\30\0"+
    "\1\5\7\0\3\5\1\0\10\5\2\0\6\5\2\0\2\5\2\0\3\5\10\0\2\5\4\0\2\5\1\0\1\5\1\0"+
    "\1\5\20\0\2\5\1\0\6\5\3\0\3\5\1\0\4\5\3\0\2\5\1\0\1\5\1\0\2\5\3\0\2\5\3\0"+
    "\3\5\3\0\5\5\3\0\3\5\1\0\4\5\2\0\1\5\6\0\1\5\10\0\4\5\1\0\10\5\1\0\3\5\1\0"+
    "\30\5\3\0\10\5\1\0\3\5\1\0\4\5\7\0\2\5\1\0\3\5\5\0\4\5\1\0\5\5\2\0\4\5\5\0"+
    "\2\5\7\0\1\5\2\0\2\5\16\0\3\5\1\0\10\5\1\0\7\5\1\0\3\5\1\0\5\5\5\0\4\5\7\0"+
    "\1\5\12\0\6\5\2\0\2\5\1\0\22\5\3\0\10\5\1\0\11\5\1\0\1\5\2\0\7\5\3\0\1\5\4"+
    "\0\6\5\1\0\1\5\1\0\10\5\2\0\2\5\14\0\17\5\1\0\12\5\7\0\2\5\1\0\1\5\2\0\2\5"+
    "\1\0\1\5\2\0\1\5\6\0\4\5\1\0\7\5\1\0\3\5\1\0\1\5\1\0\1\5\2\0\2\5\1\0\15\5"+
    "\1\0\3\5\2\0\5\5\1\0\1\5\1\0\6\5\2\0\12\5\2\0\4\5\10\0\2\5\13\0\1\5\1\0\1"+
    "\5\1\0\1\5\4\0\12\5\1\0\24\5\3\0\5\5\1\0\12\5\6\0\1\5\11\0\6\5\1\0\1\5\5\0"+
    "\1\5\2\0\13\5\1\0\15\5\1\0\4\5\2\0\7\5\1\0\1\5\1\0\4\5\2\0\1\5\1\0\4\5\2\0"+
    "\7\5\1\0\1\5\1\0\4\5\2\0\16\5\2\0\6\5\2\0\1\6\32\5\3\0\13\5\7\0\15\5\1\0\7"+
    "\5\13\0\4\5\14\0\1\5\1\0\2\5\14\0\4\5\3\0\1\5\4\0\2\5\15\0\3\5\11\0\1\5\23"+
    "\0\10\5\1\0\23\5\1\0\2\5\6\0\6\5\5\0\15\5\1\0\1\5\1\0\1\5\1\0\1\5\1\0\6\5"+
    "\1\0\7\5\1\0\1\5\3\0\3\5\1\0\7\5\3\0\4\5\2\0\6\5\4\0\13\6\15\0\2\3\5\0\1\6"+
    "\17\0\1\5\4\0\1\5\12\0\1\6\1\0\1\5\15\0\1\5\2\0\1\5\4\0\1\5\2\0\12\5\1\0\1"+
    "\5\3\0\5\5\6\0\1\5\1\0\1\5\1\0\1\5\1\0\4\5\1\0\1\5\5\0\5\5\4\0\1\5\1\0\5\5"+
    "\6\0\15\5\7\0\10\5\11\0\7\5\1\0\7\5\1\0\1\6\4\0\3\5\11\0\5\5\2\0\5\5\3\0\7"+
    "\5\2\0\2\5\2\0\3\5\5\0\16\5\1\0\12\5\1\0\1\5\7\0\11\5\2\0\27\5\2\0\15\5\3"+
    "\0\1\5\1\0\1\5\2\0\1\5\16\0\1\5\2\0\5\5\12\0\6\5\2\0\6\5\2\0\6\5\11\0\13\5"+
    "\1\0\2\5\2\0\7\5\4\0\5\5\3\0\5\5\5\0\12\5\1\0\5\5\1\0\1\5\1\0\2\5\1\0\2\5"+
    "\1\0\12\5\3\0\15\5\3\0\2\5\30\0\16\5\4\0\1\5\2\0\6\5\2\0\6\5\2\0\6\5\2\0\3"+
    "\5\3\0\14\5\1\0\16\5\1\0\2\5\1\0\1\5\15\0\1\5\2\0\4\5\4\0\10\5\1\0\5\5\12"+
    "\0\6\5\2\0\1\5\1\0\14\5\1\0\2\5\3\0\1\5\2\0\4\5\1\0\2\5\12\0\10\5\6\0\6\5"+
    "\1\0\2\5\5\0\10\5\1\0\3\5\1\0\13\5\4\0\3\5\4\0\5\5\2\0\1\5\11\0\5\5\5\0\3"+
    "\5\3\0\13\5\1\0\1\5\3\0\10\5\6\0\1\5\1\0\7\5\1\0\1\5\1\0\4\5\1\0\2\5\6\0\1"+
    "\5\5\0\7\5\2\0\7\5\3\0\6\5\1\0\1\5\10\0\6\5\2\0\10\5\10\0\6\5\2\0\1\5\3\0"+
    "\1\5\13\0\10\5\5\0\15\5\3\0\2\5\6\0\5\5\3\0\6\5\10\0\10\5\2\0\7\5\16\0\4\5"+
    "\4\0\3\5\15\0\1\5\2\0\2\5\2\0\4\5\1\0\14\5\1\0\1\5\1\0\7\5\1\0\21\5\1\0\4"+
    "\5\2\0\10\5\1\0\7\5\1\0\14\5\1\0\4\5\1\0\5\5\1\0\1\5\3\0\11\5\1\0\10\5\2\0"+
    "\2\5\5\0\1\5\16\0\1\5\13\0\2\5\1\0\2\5\1\0\5\5\6\0\2\5\1\0\1\5\2\0\1\5\1\0"+
    "\12\5\1\0\4\5\1\0\1\5\1\0\1\5\6\0\1\5\4\0\1\5\1\0\1\5\1\0\1\5\1\0\3\5\1\0"+
    "\2\5\1\0\1\5\2\0\1\5\1\0\1\5\1\0\1\5\1\0\1\5\1\0\1\5\1\0\2\5\1\0\1\5\2\0\4"+
    "\5\1\0\7\5\1\0\4\5\1\0\4\5\1\0\1\5\1\0\12\5\1\0\5\5\1\0\3\5\1\0\5\5\1\0\5"+
    "\5");

  /** 
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\14\0\1\1\1\2\2\1\1\3\5\1\1\2\3\1"+
    "\1\2\1\4\1\5\1\6\1\7\1\6\1\1\1\10"+
    "\1\11\1\12\5\1\7\0\1\13\1\14\1\15\1\0"+
    "\1\16\13\0\1\4\1\5\1\6\2\17\2\0\1\20"+
    "\1\10\1\21\2\22\7\0\1\23\1\24\2\0\1\25"+
    "\1\26\1\0\2\13\5\0\1\16\10\0\1\27\2\30"+
    "\6\0\1\31\10\0\1\32\1\30\1\31\3\0\1\31"+
    "\1\33\7\0\1\34\2\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[142];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** 
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\42\0\104\0\146\0\210\0\252\0\314\0\356"+
    "\0\u0110\0\u0132\0\u0154\0\u0176\0\u0198\0\u01ba\0\u01dc\0\u01fe"+
    "\0\u0220\0\u0242\0\u0264\0\u0286\0\u02a8\0\u02ca\0\u02ec\0\u030e"+
    "\0\u0330\0\u0352\0\u0374\0\u0396\0\u03b8\0\u03da\0\u0198\0\u03fc"+
    "\0\u041e\0\u0440\0\u0462\0\u0198\0\u0484\0\u04a6\0\u04c8\0\u04ea"+
    "\0\u050c\0\u052e\0\u01fe\0\u0550\0\u0572\0\u0594\0\u05b6\0\u01dc"+
    "\0\u05d8\0\u0198\0\u05fa\0\u0242\0\u0198\0\u061c\0\u063e\0\u0660"+
    "\0\u0682\0\u06a4\0\u02ca\0\u030e\0\u06c6\0\u06e8\0\u070a\0\u072c"+
    "\0\u074e\0\u0770\0\u0792\0\u07b4\0\u0198\0\u07d6\0\u041e\0\u0198"+
    "\0\u07f8\0\u0198\0\u081a\0\u083c\0\u083c\0\u0484\0\u04a6\0\u085e"+
    "\0\u0880\0\u08a2\0\u04c8\0\u0198\0\u08c4\0\u08e6\0\u04ea\0\u0198"+
    "\0\u0908\0\u050c\0\u0198\0\u05b6\0\u092a\0\u094c\0\u096e\0\u0990"+
    "\0\u09b2\0\u0242\0\u09d4\0\u09f6\0\u0a18\0\u0a3a\0\u0a5c\0\u0a7e"+
    "\0\u0aa0\0\u0ac2\0\u083c\0\u0ae4\0\u0198\0\u0b06\0\u0b28\0\u0b4a"+
    "\0\u0b6c\0\u0b8e\0\u0bb0\0\u0bd2\0\u0bf4\0\u0c16\0\u0c38\0\u0c5a"+
    "\0\u0c7c\0\u0c9e\0\u0cc0\0\u0ce2\0\u0198\0\u04a6\0\u0d04\0\u0d26"+
    "\0\u0d48\0\u0d6a\0\u0d8c\0\u0dae\0\u0dd0\0\u0df2\0\u0e14\0\u0e36"+
    "\0\u0e58\0\u0e7a\0\u0e9c\0\u0ebe\0\u0ee0\0\u0f02";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[142];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /** 
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\15\4\16\1\17\1\20\1\21\1\22\1\15\1\23"+
    "\10\17\1\24\1\17\1\25\5\17\2\15\1\26\5\15"+
    "\4\27\1\17\1\30\1\21\1\22\1\15\1\31\4\17"+
    "\1\32\3\17\1\24\1\17\1\25\5\17\2\15\1\26"+
    "\5\15\4\33\1\34\4\15\21\34\10\15\4\33\1\35"+
    "\4\15\21\35\10\15\4\33\1\36\4\15\21\36\3\15"+
    "\1\37\4\15\4\33\1\40\4\15\21\40\10\15\4\33"+
    "\1\41\4\15\21\41\10\15\4\33\1\42\2\15\1\22"+
    "\1\15\21\42\5\15\1\43\1\44\1\15\4\33\1\45"+
    "\2\15\1\46\1\15\21\45\10\15\4\33\1\47\4\15"+
    "\21\47\10\15\4\33\1\50\4\15\21\50\10\15\4\33"+
    "\1\51\4\15\21\51\7\15\43\0\4\16\1\52\1\53"+
    "\3\0\1\54\10\52\1\55\1\52\1\56\5\52\10\0"+
    "\4\57\1\60\1\57\3\0\21\60\1\61\1\62\1\0"+
    "\1\63\4\0\4\53\1\52\1\53\3\0\1\54\10\52"+
    "\1\55\1\52\1\56\5\52\7\0\1\21\2\0\37\21"+
    "\1\64\1\0\6\64\1\65\1\66\30\64\1\0\4\57"+
    "\1\60\1\57\3\0\7\60\1\67\11\60\1\61\1\62"+
    "\1\0\1\63\4\0\4\57\1\60\1\57\3\0\2\60"+
    "\1\70\16\60\1\61\1\62\1\0\1\63\4\0\4\57"+
    "\1\60\1\57\3\0\14\60\1\71\1\72\3\60\1\61"+
    "\1\62\1\0\1\63\4\0\4\73\1\52\1\73\3\0"+
    "\21\52\10\0\4\27\1\52\1\74\3\0\1\75\4\52"+
    "\1\76\3\52\1\55\1\52\1\56\5\52\10\0\4\74"+
    "\1\52\1\74\3\0\1\75\4\52\1\76\3\52\1\55"+
    "\1\52\1\56\5\52\10\0\4\57\1\60\1\57\3\0"+
    "\1\60\1\77\5\60\1\67\11\60\1\61\1\62\1\0"+
    "\1\63\4\0\4\57\1\60\1\57\3\0\4\60\1\100"+
    "\14\60\1\61\1\62\1\0\1\63\4\0\4\33\36\0"+
    "\4\101\1\34\1\101\3\0\21\34\10\0\4\102\1\35"+
    "\1\102\3\0\21\35\10\0\4\103\1\36\1\103\3\0"+
    "\21\36\10\0\1\104\2\105\1\0\1\40\4\0\21\40"+
    "\10\0\4\106\1\107\1\106\3\0\21\107\4\0\1\110"+
    "\3\0\4\111\1\42\1\111\3\0\21\42\3\0\1\112"+
    "\4\0\4\43\1\0\1\43\34\0\1\113\2\114\1\115"+
    "\1\116\1\115\3\0\21\116\7\0\1\117\1\0\6\117"+
    "\1\120\1\121\30\117\1\0\4\122\1\123\1\122\3\0"+
    "\21\123\1\124\2\0\1\125\4\0\4\126\1\127\1\126"+
    "\3\0\21\127\1\130\2\0\1\131\4\0\4\57\1\132"+
    "\1\57\3\0\21\132\1\133\2\0\1\63\4\0\4\57"+
    "\1\52\1\57\3\0\21\52\1\134\2\0\1\63\4\0"+
    "\4\57\1\52\1\57\3\0\7\52\1\135\11\52\1\134"+
    "\2\0\1\63\4\0\4\57\1\52\1\57\3\0\2\52"+
    "\1\136\16\52\1\134\2\0\1\63\4\0\4\57\1\52"+
    "\1\57\3\0\14\52\1\137\1\140\3\52\1\134\2\0"+
    "\1\63\4\0\4\57\1\0\1\57\27\0\1\63\4\0"+
    "\4\57\1\141\1\57\3\0\21\141\1\0\1\62\1\0"+
    "\1\63\4\0\4\63\1\0\1\63\33\0\1\64\1\0"+
    "\6\64\1\142\1\66\30\64\1\0\4\57\1\60\1\57"+
    "\3\0\1\143\20\60\1\61\1\62\1\0\1\63\4\0"+
    "\4\57\1\60\1\57\3\0\20\60\1\144\1\61\1\62"+
    "\1\0\1\63\4\0\4\57\1\60\1\57\3\0\4\60"+
    "\1\145\14\60\1\61\1\62\1\0\1\63\4\0\4\57"+
    "\1\60\1\57\3\0\16\60\1\146\2\60\1\61\1\62"+
    "\1\0\1\63\4\0\4\57\1\52\1\57\3\0\1\52"+
    "\1\147\5\52\1\135\11\52\1\134\2\0\1\63\4\0"+
    "\4\57\1\52\1\57\3\0\4\52\1\150\14\52\1\134"+
    "\2\0\1\63\4\0\4\57\1\60\1\57\3\0\2\60"+
    "\1\151\16\60\1\61\1\62\1\0\1\63\4\0\4\57"+
    "\1\60\1\57\3\0\6\60\1\152\12\60\1\61\1\62"+
    "\1\0\1\63\4\0\4\101\1\0\1\101\34\0\4\102"+
    "\1\0\1\102\34\0\4\103\1\0\1\103\35\0\1\105"+
    "\40\0\4\106\1\0\1\106\30\0\1\110\3\0\4\111"+
    "\1\0\1\111\27\0\1\112\4\0\1\113\1\153\1\114"+
    "\1\115\1\0\1\115\34\0\1\113\2\114\1\115\1\0"+
    "\1\115\34\0\1\154\2\155\36\0\1\117\1\0\6\117"+
    "\1\156\1\121\30\117\1\0\4\122\1\0\1\122\27\0"+
    "\1\125\4\0\4\125\1\0\1\125\34\0\4\126\1\0"+
    "\1\126\27\0\1\131\4\0\4\131\1\0\1\131\34\0"+
    "\4\57\1\52\1\57\3\0\1\157\20\52\1\134\2\0"+
    "\1\63\4\0\4\57\1\52\1\57\3\0\20\52\1\160"+
    "\1\134\2\0\1\63\4\0\4\57\1\52\1\57\3\0"+
    "\4\52\1\161\14\52\1\134\2\0\1\63\4\0\4\57"+
    "\1\52\1\57\3\0\16\52\1\162\2\52\1\134\2\0"+
    "\1\63\10\0\1\141\4\0\21\141\1\163\1\62\6\0"+
    "\4\57\1\60\1\57\3\0\12\60\1\164\6\60\1\61"+
    "\1\62\1\0\1\63\4\0\4\57\1\60\1\57\3\0"+
    "\4\60\1\165\14\60\1\61\1\62\1\0\1\63\4\0"+
    "\4\57\1\60\1\57\3\0\7\60\1\166\11\60\1\61"+
    "\1\62\1\0\1\63\4\0\4\57\1\60\1\57\3\0"+
    "\17\60\1\167\1\60\1\61\1\62\1\0\1\63\4\0"+
    "\4\57\1\52\1\57\3\0\2\52\1\170\16\52\1\134"+
    "\2\0\1\63\4\0\4\57\1\52\1\57\3\0\6\52"+
    "\1\171\12\52\1\134\2\0\1\63\4\0\4\57\1\60"+
    "\1\57\3\0\3\60\1\172\15\60\1\61\1\62\1\0"+
    "\1\63\4\0\4\57\1\60\1\57\3\0\1\173\1\60"+
    "\1\174\16\60\1\61\1\62\1\0\1\63\5\0\1\175"+
    "\37\0\1\117\1\154\2\176\4\117\1\120\1\121\30\117"+
    "\1\0\4\57\1\52\1\57\3\0\12\52\1\177\6\52"+
    "\1\134\2\0\1\63\4\0\4\57\1\52\1\57\3\0"+
    "\4\52\1\200\14\52\1\134\2\0\1\63\4\0\4\57"+
    "\1\52\1\57\3\0\7\52\1\201\11\52\1\134\2\0"+
    "\1\63\4\0\4\57\1\52\1\57\3\0\17\52\1\202"+
    "\1\52\1\134\2\0\1\63\10\0\1\141\4\0\21\141"+
    "\1\0\1\62\6\0\4\203\1\60\1\203\3\0\21\60"+
    "\1\61\1\62\1\0\1\63\4\0\4\57\1\60\1\57"+
    "\3\0\11\60\1\164\7\60\1\61\1\62\1\0\1\63"+
    "\4\0\4\57\1\60\1\57\3\0\4\60\1\167\14\60"+
    "\1\61\1\62\1\0\1\63\4\0\4\204\1\60\1\204"+
    "\3\0\21\60\1\61\1\62\1\0\1\63\4\0\4\57"+
    "\1\52\1\57\3\0\3\52\1\205\15\52\1\134\2\0"+
    "\1\63\4\0\4\57\1\52\1\57\3\0\1\206\1\52"+
    "\1\207\16\52\1\134\2\0\1\63\4\0\4\57\1\60"+
    "\1\57\3\0\4\60\1\210\14\60\1\61\1\62\1\0"+
    "\1\63\4\0\4\57\1\60\1\57\3\0\7\60\1\172"+
    "\11\60\1\61\1\62\1\0\1\63\4\0\4\57\1\60"+
    "\1\57\3\0\10\60\1\211\10\60\1\61\1\62\1\0"+
    "\1\63\4\0\4\203\1\52\1\203\3\0\21\52\1\134"+
    "\2\0\1\63\4\0\4\57\1\52\1\57\3\0\11\52"+
    "\1\177\7\52\1\134\2\0\1\63\4\0\4\57\1\52"+
    "\1\57\3\0\4\52\1\202\14\52\1\134\2\0\1\63"+
    "\4\0\4\204\1\52\1\204\3\0\21\52\1\134\2\0"+
    "\1\63\4\0\4\203\1\0\1\203\27\0\1\63\4\0"+
    "\4\204\1\0\1\204\27\0\1\63\4\0\4\57\1\52"+
    "\1\57\3\0\4\52\1\212\14\52\1\134\2\0\1\63"+
    "\4\0\4\57\1\52\1\57\3\0\7\52\1\205\11\52"+
    "\1\134\2\0\1\63\4\0\4\57\1\52\1\57\3\0"+
    "\10\52\1\213\10\52\1\134\2\0\1\63\4\0\4\214"+
    "\1\60\1\214\3\0\21\60\1\61\1\62\1\0\1\63"+
    "\4\0\4\57\1\60\1\57\3\0\11\60\1\215\7\60"+
    "\1\61\1\62\1\0\1\63\4\0\4\214\1\52\1\214"+
    "\3\0\21\52\1\134\2\0\1\63\4\0\4\57\1\52"+
    "\1\57\3\0\11\52\1\216\7\52\1\134\2\0\1\63"+
    "\4\0\4\214\1\0\1\214\27\0\1\63\4\0\4\57"+
    "\1\60\1\57\3\0\12\60\1\210\6\60\1\61\1\62"+
    "\1\0\1\63\4\0\4\57\1\52\1\57\3\0\12\52"+
    "\1\212\6\52\1\134\2\0\1\63\3\0";

  private static int [] zzUnpackTrans() {
    int [] result = new int[3876];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /* error codes */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  private static final int ZZ_NO_MATCH = 1;
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /* error messages for the codes above */
  private static final String[] ZZ_ERROR_MSG = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\14\0\1\11\21\1\1\11\4\1\1\11\5\1\7\0"+
    "\1\1\1\11\1\1\1\0\1\11\13\0\4\1\1\11"+
    "\2\0\1\11\1\1\1\11\2\1\7\0\1\11\1\1"+
    "\2\0\1\11\1\1\1\0\1\11\1\1\5\0\1\1"+
    "\10\0\2\1\1\11\6\0\1\1\10\0\1\11\2\1"+
    "\3\0\2\1\7\0\1\1\2\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[142];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** the input device */
  private java.io.Reader zzReader;

  /** the current state of the DFA */
  private int zzState;

  /** the current lexical state */
  private int zzLexicalState = YYINITIAL;

  /** this buffer contains the current text to be matched and is
      the source of the yytext() string */
  private CharSequence zzBuffer = "";

  /** the textposition at the last accepting state */
  private int zzMarkedPos;

  /** the current text position in the buffer */
  private int zzCurrentPos;

  /** startRead marks the beginning of the yytext() string in the buffer */
  private int zzStartRead;

  /** endRead marks the last character in the buffer, that has been read
      from input */
  private int zzEndRead;

  /**
   * zzAtBOL == true <=> the scanner is currently at the beginning of a line
   */
  private boolean zzAtBOL = true;

  /** zzAtEOF == true <=> the scanner is at the EOF */
  private boolean zzAtEOF;

  /** denotes if the user-EOF-code has already been executed */
  private boolean zzEOFDone;


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  RenpyLexer(java.io.Reader in) {
    this.zzReader = in;
  }


  /** 
   * Unpacks the compressed character translation table.
   *
   * @param packed   the packed character translation table
   * @return         the unpacked character translation table
   */
  private static char [] zzUnpackCMap(String packed) {
    int size = 0;
    for (int i = 0, length = packed.length(); i < length; i += 2) {
      size += packed.charAt(i);
    }
    char[] map = new char[size];
    int i = 0;  /* index in packed string  */
    int j = 0;  /* index in unpacked array */
    while (i < packed.length()) {
      int  count = packed.charAt(i++);
      char value = packed.charAt(i++);
      do map[j++] = value; while (--count > 0);
    }
    return map;
  }

  public final int getTokenStart() {
    return zzStartRead;
  }

  public final int getTokenEnd() {
    return getTokenStart() + yylength();
  }

  public void reset(CharSequence buffer, int start, int end, int initialState) {
    zzBuffer = buffer;
    zzCurrentPos = zzMarkedPos = zzStartRead = start;
    zzAtEOF  = false;
    zzAtBOL = true;
    zzEndRead = end;
    yybegin(initialState);
  }

  /**
   * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
   *
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {
    return true;
  }


  /**
   * Returns the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   */
  public final CharSequence yytext() {
    return zzBuffer.subSequence(zzStartRead, zzMarkedPos);
  }


  /**
   * Returns the character at position <tt>pos</tt> from the
   * matched text.
   *
   * It is equivalent to yytext().charAt(pos), but faster
   *
   * @param pos the position of the character to fetch.
   *            A value from 0 to yylength()-1.
   *
   * @return the character at position pos
   */
  public final char yycharat(int pos) {
    return zzBuffer.charAt(zzStartRead+pos);
  }


  /**
   * Returns the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occured while scanning.
   *
   * In a wellformed scanner (no or only correct usage of
   * yypushback(int) and a match-all fallback rule) this method
   * will only be called with things that "Can't Possibly Happen".
   * If this method is called, something is seriously wrong
   * (e.g. a JFlex bug producing a faulty scanner etc.).
   *
   * Usual syntax/scanner level error handling should be done
   * in error fallback rules.
   *
   * @param   errorCode  the code of the errormessage to display
   */
  private void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    }
    catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * They will be read again by then next call of the scanning method
   *
   * @param number  the number of characters to be read again.
   *                This number must not be greater than yylength()!
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


  /**
   * Contains user EOF-code, which will be executed exactly once,
   * when the end of file is reached
   */
  private void zzDoEOF() {
    if (!zzEOFDone) {
      zzEOFDone = true;
    
    }
  }


  /**
   * Resumes scanning until the next regular expression is matched,
   * the end of input is encountered or an I/O-Error occurs.
   *
   * @return      the next token
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  public IElementType advance() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    CharSequence zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      if (zzMarkedPosL > zzStartRead) {
        switch (zzBufferL.charAt(zzMarkedPosL-1)) {
        case '\n':
        case '\u000B':  // fall though
        case '\u000C':  // fall though
        case '\u0085':  // fall though
        case '\u2028':  // fall though
        case '\u2029':  // fall though
          zzAtBOL = true;
          break;
        case '\r': 
          if (zzMarkedPosL < zzEndReadL)
            zzAtBOL = zzBufferL.charAt(zzMarkedPosL) != '\n';
          else if (zzAtEOF)
            zzAtBOL = false;
          else {
            boolean eof = zzRefill();
            zzMarkedPosL = zzMarkedPos;
            zzEndReadL = zzEndRead;
            zzBufferL = zzBuffer;
            if (eof) 
              zzAtBOL = false;
            else 
              zzAtBOL = zzBufferL.charAt(zzMarkedPosL) != '\n';
          }
          break;
        default:
          zzAtBOL = false;
        }
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      if (zzAtBOL)
        zzState = ZZ_LEXSTATE[zzLexicalState+1];
      else
        zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL/*, zzEndReadL*/);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL/*, zzEndReadL*/);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + ZZ_CMAP(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        zzDoEOF();
        return null;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1: 
            { return TokenType.BAD_CHARACTER;
            } 
            // fall through
          case 29: break;
          case 2: 
            { yybegin(YYINITIAL); return TokenType.WHITE_SPACE;
            } 
            // fall through
          case 30: break;
          case 3: 
            { return RenpyTypes.COMMENT;
            } 
            // fall through
          case 31: break;
          case 4: 
            { yybegin(WAITING_TAGS_DEFINE); return RenpyTypes.VARIABLE;
            } 
            // fall through
          case 32: break;
          case 5: 
            { yybegin(WAITING_TAGS_SHOW); return RenpyTypes.VARIABLE;
            } 
            // fall through
          case 33: break;
          case 6: 
            { return RenpyTypes.TAG;
            } 
            // fall through
          case 34: break;
          case 7: 
            { yybegin(YYINITIAL); return RenpyTypes.SEPARATOR;
            } 
            // fall through
          case 35: break;
          case 8: 
            { return RenpyTypes.VALUE;
            } 
            // fall through
          case 36: break;
          case 9: 
            { return RenpyTypes.SEPARATOR;
            } 
            // fall through
          case 37: break;
          case 10: 
            { yybegin(YYINITIAL); return RenpyTypes.FUNCTION_CALL;
            } 
            // fall through
          case 38: break;
          case 11: 
            { yybegin(CLASS1); return RenpyTypes.VARIABLE1;
            } 
            // fall through
          case 39: break;
          case 12: 
            { yybegin(WAITING_PARAMS); return RenpyTypes.FUNCTION_CALL;
            } 
            // fall through
          case 40: break;
          case 13: 
            { yybegin(WAITING_VALUE); return RenpyTypes.VARIABLE1;
            } 
            // fall through
          case 41: break;
          case 14: 
            { return RenpyTypes.STRING;
            } 
            // fall through
          case 42: break;
          case 15: 
            { yybegin(YYINITIAL); return RenpyTypes.TAG;
            } 
            // fall through
          case 43: break;
          case 16: 
            { return RenpyTypes.BLOCK_NAME;
            } 
            // fall through
          case 44: break;
          case 17: 
            { return RenpyTypes.PARAM_NAME;
            } 
            // fall through
          case 45: break;
          case 18: 
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL/*, zzStartRead, zzEndRead - zzStartRead*/, zzMarkedPos, -1);
            { yybegin(YYINITIAL); return RenpyTypes.VALUE;
            } 
            // fall through
          case 46: break;
          case 19: 
            { yybegin(CLASS2); return RenpyTypes.VARIABLE2;
            } 
            // fall through
          case 47: break;
          case 20: 
            { yybegin(WAITING_VALUE); return RenpyTypes.VARIABLE2;
            } 
            // fall through
          case 48: break;
          case 21: 
            { yybegin(CLASS3); return RenpyTypes.VARIABLE3;
            } 
            // fall through
          case 49: break;
          case 22: 
            { yybegin(WAITING_VALUE); return RenpyTypes.VARIABLE3;
            } 
            // fall through
          case 50: break;
          case 23: 
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL/*, zzStartRead, zzEndRead - zzStartRead*/, zzMarkedPos, -2);
            { yybegin(YYINITIAL); return RenpyTypes.VALUE;
            } 
            // fall through
          case 51: break;
          case 24: 
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL/*, zzStartRead, zzEndRead - zzStartRead*/, zzMarkedPos, -1);
            { yybegin(YYINITIAL); return RenpyTypes.STRING;
            } 
            // fall through
          case 52: break;
          case 25: 
            { yybegin(WAITING_BLOCK_NAME); return RenpyTypes.BLOCK_START;
            } 
            // fall through
          case 53: break;
          case 26: 
            // lookahead expression with fixed lookahead length
            zzMarkedPos = Character.offsetByCodePoints
                (zzBufferL/*, zzStartRead, zzEndRead - zzStartRead*/, zzMarkedPos, -2);
            { yybegin(YYINITIAL); return RenpyTypes.STRING;
            } 
            // fall through
          case 54: break;
          case 27: 
            { yybegin(WAITING_VARIABLE_NAME_SHOW); return RenpyTypes.DEFINE;
            } 
            // fall through
          case 55: break;
          case 28: 
            { yybegin(WAITING_VARIABLE_NAME_DEFINE); return RenpyTypes.DEFINE;
            } 
            // fall through
          case 56: break;
          default:
            zzScanError(ZZ_NO_MATCH);
          }
      }
    }
  }


}
